from aggregator import AggregateDataManager
from spatial_data_analyzer import SpatialAnalyzer
from GM_data_analyzer import GMEstablishmentAnalyzer

if __name__ == "__main__":
    experiments = {
        # "VC_only": "36f37682-158a-e911-a2c1-c4346bcb1555",
        # "VC_and_GM": "35f37682-158a-e911-a2c1-c4346bcb1555",
        # "No_interventions": "e264b5ee-be8b-e911-a2c1-c4346bcb1555",
        # "GM_only": "4880820c-8991-e911-a2c1-c4346bcb1555",
        # "VC_and_GM_vary_release": "b8bb4828-a599-e911-a2c1-c4346bcb1555",
        "VC_GM_test": "54ecd4e4-45c9-e911-a2c1-c4346bcb1555"
    }
    channels = ['Prevalence', 'Daily_EIR', 'Adult_Vectors', 'New_Clinical_Cases']
    sweep_vars = ['Run_Number', 'Release_Number', 'Copy_To_Likelihood',
                  'ITN_Coverage', 'Transmission_To_Human',
                  'Start_Day', 'Num_Nodes']

    for expt_name, exp_id in experiments.items():
        am = AggregateDataManager(exp_list=exp_id,
                                  aggregators=
                                  [SpatialAnalyzer(exp_name=expt_name,
                                                   spatial_channels=channels,
                                                   sweep_variables=sweep_vars
                                                   ),
                                   GMEstablishmentAnalyzer(exp_name=expt_name,
                                                           sweep_variables=sweep_vars
                                                           )
                                   ]
                                  )
        am.analyze()
